package com.hfkj.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsGasChannelConfigExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsGasChannelConfigExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeIsNull() {
            addCriterion("gas_channel_type is null");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeIsNotNull() {
            addCriterion("gas_channel_type is not null");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeEqualTo(Integer value) {
            addCriterion("gas_channel_type =", value, "gasChannelType");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeNotEqualTo(Integer value) {
            addCriterion("gas_channel_type <>", value, "gasChannelType");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeGreaterThan(Integer value) {
            addCriterion("gas_channel_type >", value, "gasChannelType");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("gas_channel_type >=", value, "gasChannelType");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeLessThan(Integer value) {
            addCriterion("gas_channel_type <", value, "gasChannelType");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeLessThanOrEqualTo(Integer value) {
            addCriterion("gas_channel_type <=", value, "gasChannelType");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeIn(List<Integer> values) {
            addCriterion("gas_channel_type in", values, "gasChannelType");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeNotIn(List<Integer> values) {
            addCriterion("gas_channel_type not in", values, "gasChannelType");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeBetween(Integer value1, Integer value2) {
            addCriterion("gas_channel_type between", value1, value2, "gasChannelType");
            return (Criteria) this;
        }

        public Criteria andGasChannelTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("gas_channel_type not between", value1, value2, "gasChannelType");
            return (Criteria) this;
        }

        public Criteria andTradeStatusIsNull() {
            addCriterion("trade_status is null");
            return (Criteria) this;
        }

        public Criteria andTradeStatusIsNotNull() {
            addCriterion("trade_status is not null");
            return (Criteria) this;
        }

        public Criteria andTradeStatusEqualTo(Boolean value) {
            addCriterion("trade_status =", value, "tradeStatus");
            return (Criteria) this;
        }

        public Criteria andTradeStatusNotEqualTo(Boolean value) {
            addCriterion("trade_status <>", value, "tradeStatus");
            return (Criteria) this;
        }

        public Criteria andTradeStatusGreaterThan(Boolean value) {
            addCriterion("trade_status >", value, "tradeStatus");
            return (Criteria) this;
        }

        public Criteria andTradeStatusGreaterThanOrEqualTo(Boolean value) {
            addCriterion("trade_status >=", value, "tradeStatus");
            return (Criteria) this;
        }

        public Criteria andTradeStatusLessThan(Boolean value) {
            addCriterion("trade_status <", value, "tradeStatus");
            return (Criteria) this;
        }

        public Criteria andTradeStatusLessThanOrEqualTo(Boolean value) {
            addCriterion("trade_status <=", value, "tradeStatus");
            return (Criteria) this;
        }

        public Criteria andTradeStatusIn(List<Boolean> values) {
            addCriterion("trade_status in", values, "tradeStatus");
            return (Criteria) this;
        }

        public Criteria andTradeStatusNotIn(List<Boolean> values) {
            addCriterion("trade_status not in", values, "tradeStatus");
            return (Criteria) this;
        }

        public Criteria andTradeStatusBetween(Boolean value1, Boolean value2) {
            addCriterion("trade_status between", value1, value2, "tradeStatus");
            return (Criteria) this;
        }

        public Criteria andTradeStatusNotBetween(Boolean value1, Boolean value2) {
            addCriterion("trade_status not between", value1, value2, "tradeStatus");
            return (Criteria) this;
        }

        public Criteria andShowStatusIsNull() {
            addCriterion("show_status is null");
            return (Criteria) this;
        }

        public Criteria andShowStatusIsNotNull() {
            addCriterion("show_status is not null");
            return (Criteria) this;
        }

        public Criteria andShowStatusEqualTo(Boolean value) {
            addCriterion("show_status =", value, "showStatus");
            return (Criteria) this;
        }

        public Criteria andShowStatusNotEqualTo(Boolean value) {
            addCriterion("show_status <>", value, "showStatus");
            return (Criteria) this;
        }

        public Criteria andShowStatusGreaterThan(Boolean value) {
            addCriterion("show_status >", value, "showStatus");
            return (Criteria) this;
        }

        public Criteria andShowStatusGreaterThanOrEqualTo(Boolean value) {
            addCriterion("show_status >=", value, "showStatus");
            return (Criteria) this;
        }

        public Criteria andShowStatusLessThan(Boolean value) {
            addCriterion("show_status <", value, "showStatus");
            return (Criteria) this;
        }

        public Criteria andShowStatusLessThanOrEqualTo(Boolean value) {
            addCriterion("show_status <=", value, "showStatus");
            return (Criteria) this;
        }

        public Criteria andShowStatusIn(List<Boolean> values) {
            addCriterion("show_status in", values, "showStatus");
            return (Criteria) this;
        }

        public Criteria andShowStatusNotIn(List<Boolean> values) {
            addCriterion("show_status not in", values, "showStatus");
            return (Criteria) this;
        }

        public Criteria andShowStatusBetween(Boolean value1, Boolean value2) {
            addCriterion("show_status between", value1, value2, "showStatus");
            return (Criteria) this;
        }

        public Criteria andShowStatusNotBetween(Boolean value1, Boolean value2) {
            addCriterion("show_status not between", value1, value2, "showStatus");
            return (Criteria) this;
        }

        public Criteria andChannelTypeIsNull() {
            addCriterion("channel_type is null");
            return (Criteria) this;
        }

        public Criteria andChannelTypeIsNotNull() {
            addCriterion("channel_type is not null");
            return (Criteria) this;
        }

        public Criteria andChannelTypeEqualTo(Integer value) {
            addCriterion("channel_type =", value, "channelType");
            return (Criteria) this;
        }

        public Criteria andChannelTypeNotEqualTo(Integer value) {
            addCriterion("channel_type <>", value, "channelType");
            return (Criteria) this;
        }

        public Criteria andChannelTypeGreaterThan(Integer value) {
            addCriterion("channel_type >", value, "channelType");
            return (Criteria) this;
        }

        public Criteria andChannelTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("channel_type >=", value, "channelType");
            return (Criteria) this;
        }

        public Criteria andChannelTypeLessThan(Integer value) {
            addCriterion("channel_type <", value, "channelType");
            return (Criteria) this;
        }

        public Criteria andChannelTypeLessThanOrEqualTo(Integer value) {
            addCriterion("channel_type <=", value, "channelType");
            return (Criteria) this;
        }

        public Criteria andChannelTypeIn(List<Integer> values) {
            addCriterion("channel_type in", values, "channelType");
            return (Criteria) this;
        }

        public Criteria andChannelTypeNotIn(List<Integer> values) {
            addCriterion("channel_type not in", values, "channelType");
            return (Criteria) this;
        }

        public Criteria andChannelTypeBetween(Integer value1, Integer value2) {
            addCriterion("channel_type between", value1, value2, "channelType");
            return (Criteria) this;
        }

        public Criteria andChannelTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("channel_type not between", value1, value2, "channelType");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoIsNull() {
            addCriterion("channel_mer_no is null");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoIsNotNull() {
            addCriterion("channel_mer_no is not null");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoEqualTo(String value) {
            addCriterion("channel_mer_no =", value, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoNotEqualTo(String value) {
            addCriterion("channel_mer_no <>", value, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoGreaterThan(String value) {
            addCriterion("channel_mer_no >", value, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoGreaterThanOrEqualTo(String value) {
            addCriterion("channel_mer_no >=", value, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoLessThan(String value) {
            addCriterion("channel_mer_no <", value, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoLessThanOrEqualTo(String value) {
            addCriterion("channel_mer_no <=", value, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoLike(String value) {
            addCriterion("channel_mer_no like", value, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoNotLike(String value) {
            addCriterion("channel_mer_no not like", value, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoIn(List<String> values) {
            addCriterion("channel_mer_no in", values, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoNotIn(List<String> values) {
            addCriterion("channel_mer_no not in", values, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoBetween(String value1, String value2) {
            addCriterion("channel_mer_no between", value1, value2, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerNoNotBetween(String value1, String value2) {
            addCriterion("channel_mer_no not between", value1, value2, "channelMerNo");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyIsNull() {
            addCriterion("channel_mer_key is null");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyIsNotNull() {
            addCriterion("channel_mer_key is not null");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyEqualTo(String value) {
            addCriterion("channel_mer_key =", value, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyNotEqualTo(String value) {
            addCriterion("channel_mer_key <>", value, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyGreaterThan(String value) {
            addCriterion("channel_mer_key >", value, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyGreaterThanOrEqualTo(String value) {
            addCriterion("channel_mer_key >=", value, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyLessThan(String value) {
            addCriterion("channel_mer_key <", value, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyLessThanOrEqualTo(String value) {
            addCriterion("channel_mer_key <=", value, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyLike(String value) {
            addCriterion("channel_mer_key like", value, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyNotLike(String value) {
            addCriterion("channel_mer_key not like", value, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyIn(List<String> values) {
            addCriterion("channel_mer_key in", values, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyNotIn(List<String> values) {
            addCriterion("channel_mer_key not in", values, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyBetween(String value1, String value2) {
            addCriterion("channel_mer_key between", value1, value2, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andChannelMerKeyNotBetween(String value1, String value2) {
            addCriterion("channel_mer_key not between", value1, value2, "channelMerKey");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagIsNull() {
            addCriterion("ledger_account_flag is null");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagIsNotNull() {
            addCriterion("ledger_account_flag is not null");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagEqualTo(Boolean value) {
            addCriterion("ledger_account_flag =", value, "ledgerAccountFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagNotEqualTo(Boolean value) {
            addCriterion("ledger_account_flag <>", value, "ledgerAccountFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagGreaterThan(Boolean value) {
            addCriterion("ledger_account_flag >", value, "ledgerAccountFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagGreaterThanOrEqualTo(Boolean value) {
            addCriterion("ledger_account_flag >=", value, "ledgerAccountFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagLessThan(Boolean value) {
            addCriterion("ledger_account_flag <", value, "ledgerAccountFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagLessThanOrEqualTo(Boolean value) {
            addCriterion("ledger_account_flag <=", value, "ledgerAccountFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagIn(List<Boolean> values) {
            addCriterion("ledger_account_flag in", values, "ledgerAccountFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagNotIn(List<Boolean> values) {
            addCriterion("ledger_account_flag not in", values, "ledgerAccountFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagBetween(Boolean value1, Boolean value2) {
            addCriterion("ledger_account_flag between", value1, value2, "ledgerAccountFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountFlagNotBetween(Boolean value1, Boolean value2) {
            addCriterion("ledger_account_flag not between", value1, value2, "ledgerAccountFlag");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataIsNull() {
            addCriterion("ledger_account_data is null");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataIsNotNull() {
            addCriterion("ledger_account_data is not null");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataEqualTo(String value) {
            addCriterion("ledger_account_data =", value, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataNotEqualTo(String value) {
            addCriterion("ledger_account_data <>", value, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataGreaterThan(String value) {
            addCriterion("ledger_account_data >", value, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataGreaterThanOrEqualTo(String value) {
            addCriterion("ledger_account_data >=", value, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataLessThan(String value) {
            addCriterion("ledger_account_data <", value, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataLessThanOrEqualTo(String value) {
            addCriterion("ledger_account_data <=", value, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataLike(String value) {
            addCriterion("ledger_account_data like", value, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataNotLike(String value) {
            addCriterion("ledger_account_data not like", value, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataIn(List<String> values) {
            addCriterion("ledger_account_data in", values, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataNotIn(List<String> values) {
            addCriterion("ledger_account_data not in", values, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataBetween(String value1, String value2) {
            addCriterion("ledger_account_data between", value1, value2, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andLedgerAccountDataNotBetween(String value1, String value2) {
            addCriterion("ledger_account_data not between", value1, value2, "ledgerAccountData");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}